

\documentclass[twocolumn]{article}

\usepackage{stfloats}
\usepackage{lipsum}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage[section]{placeins}
\usepackage{cleveref}
\title{Examples of Figures and Subfigures\\ in a Two-column \LaTeX\
  Document}

\author{Mark E. Royer}

\date{}

\begin{document}

\maketitle

\begin{abstract}
  \lipsum[1]
\end{abstract}

\section{Introduction}
\label{sec:intro}

\lipsum[2]

\begin{figure}[!htb]
  \centering
  \includegraphics[width=\columnwidth]{example-image}
  \caption{Regular floating figure.}
  \label{fig:intro}
\end{figure}

\lipsum[2]

\section{The spark of an idea}
\label{sec:idea}

\lipsum[1]

A really big image is shown in Figure \ref{fig:first}.  It spans
two-columns.  Can you believe it?

\begin{figure*}[!htb]
  \centering
  \includegraphics[width=.9\textwidth]{example-image-a}
  \caption{A fairly large image spanning two columns. The
    \texttt{stfloats} package is used for a little better
    \texttt{figure*} placement, and the \texttt{placeins} package is
    used to ensure the image stays in the declared section.}
  \label{fig:first}
\end{figure*}

\lipsum[1-2]

Let's look at an example using subfigures.  Figure \ref{fig:double}
shows how two subfigures may be achieved.

\begin{figure*}[!htb]
  \centering
  \begin{subfigure}[]{.49\linewidth}
    \includegraphics[width=\linewidth]{example-image-b}
    \caption{The letter B}\label{fig:b}
  \end{subfigure}
  \hspace{.005\linewidth}
  \begin{subfigure}[]{.49\linewidth}
    \includegraphics[width=\linewidth]{example-image-c}
    \caption{The letter C}\label{fig:c}
  \end{subfigure}
  \caption{Two subfigures}
  \label{fig:double}
\end{figure*}


\lipsum[1-2]

Let's try to introduce 3 subfigures.  Figure \ref{fig:three} shows
what this might look like. It has subfigures \ref{fig:threea},
\ref{fig:threeb}, and \ref{fig:threec}.

\begin{figure*}[!htb]
  \centering
  \begin{subfigure}[t]{.3\linewidth}
    \includegraphics[width=\linewidth]{example-image-a}
    \caption{The letter A}\label{fig:threea}
  \end{subfigure}
  \begin{subfigure}[t]{.3\linewidth}
    \includegraphics[width=\linewidth]{example-image-b}
    \caption{The Letter B}\label{fig:threeb}
  \end{subfigure}
  \begin{subfigure}[t]{.3\linewidth}
    \includegraphics[width=\linewidth]{example-image-c}
    \caption{The letter C}\label{fig:threec}
  \end{subfigure}
  \caption{Three subfigures happily in a row.  Introduce a blank line
    between the subfigure declaration in the \LaTeX\ file to create
    new rows.}
  \label{fig:three}
\end{figure*}

\lipsum[1]

Finally, figure \ref{fig:four} provides an example of a $2\times2$
grid. If want the grid in a single column format, modify it to use
\texttt{figure} instead of \texttt{figure*} as shown in figure
\ref{fig:single}.

\begin{figure*}[!htb]
\centering
\begin{subfigure}[t]{.49\linewidth}
  \includegraphics[width=\linewidth]{example-image-a}
  \caption{The letter A}\label{fig:foura}
\end{subfigure}
\hspace{.005\linewidth}
\begin{subfigure}[t]{.49\linewidth}
  \includegraphics[width=\linewidth]{example-image-b}
  \caption{The letter B}\label{fig:fourb}
\end{subfigure}

\begin{subfigure}[t]{.49\linewidth}
\includegraphics[width=\linewidth]{example-image-c}
\caption{The Letter C}\label{fig:fourc}
\end{subfigure}
\hspace{.005\linewidth}
\begin{subfigure}[t]{.49\linewidth}
\includegraphics[width=\linewidth]{example-image-plain}
\caption{This is \texttt{example-image-plain}.  There is no d
  option.}\label{fig:fourplain}
\end{subfigure}
\caption{Four subfigures}
\label{fig:four}
\end{figure*}


\begin{figure}[!htb]
\centering
\begin{subfigure}[t]{.49\linewidth}
  \includegraphics[width=\linewidth]{example-image-a}
  \caption{The letter A}\label{fig:singlea}
\end{subfigure}
%\hspace{.005\linewidth}
\begin{subfigure}[t]{.49\linewidth}
  \includegraphics[width=\linewidth]{example-image-b}
  \caption{The letter B}\label{fig:singleb}
\end{subfigure}

\begin{subfigure}[t]{.49\linewidth}
\includegraphics[width=\linewidth]{example-image-c}
\caption{The Letter C}\label{fig:singlec}
\end{subfigure}
%\hspace{.005\linewidth}
\begin{subfigure}[t]{.49\linewidth}
\includegraphics[width=\linewidth]{example-image-plain}
\caption{This is \texttt{example-image-plain}.  There is no d
  option.}\label{fig:singleplain}
\end{subfigure}
\caption{Four subfigures in a single column.}
\label{fig:single}
\end{figure}


\lipsum[1-5]

\section{Further discoveries of this and that}
\label{sec:disc}

\lipsum[1]

\begin{figure}[!htb]
  \centering
  \includegraphics[width=\columnwidth]{example-image}
  \caption{Regular floating figure.}
  \label{fig:last}
\end{figure}

\Cref{fig:intro,fig:last} use the standard \texttt{figure}
environment. They probably won't have any issues, but you never know.

\lipsum[1]

\section{Related work}
\label{sec:work}

\lipsum[1-4]

\section{Conclusion}
\label{sec:conc}

\lipsum[1-2]

\end{document}

